unit FMainGPX;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  Provider, OleCtrls, SHDocVw, ImgList, ActnList, Buttons;

type
  TForm1 = class(TForm)
    PanelInf: TPanel;
    Panel2: TPanel;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    tsMap: TTabSheet;
    PanelCentral: TPanel;
    pnlExpandirColapsar: TPanel;
    lblBarra: TLabel;
    pnl1: TPanel;
    img1: TImage;
    pnlMapa: TPanel;
    wbMapaGoogle: TWebBrowser;
    pnlPos: TPanel;
    Image2: TImage;
    ImageList1: TImageList;
    btnCargar: TBitBtn;
    procedure btnCerrarClick(Sender: TObject);
    procedure wbMapaGoogleDocumentComplete(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCargarClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    DoneVisualization: Boolean;
    TSPoints: TStrings;
    TS1, TS2, TS3:TStrings;

    procedure _CenterPanel(APanel: TPanel);
  public
    { Public declarations }
  end;

const
  CHAR_COMMA = ',';
  CHAR_POINT = '.';

var
  Form1: TForm1;

  // =========================================================================
  //
  // I N T E R F A C E
  //
  // =========================================================================
implementation

{$R *.dfm}

uses
  StrUtils,
  ShellAPI,
  UConstantes,
  MSHTML,
  UProcedures;

procedure TForm1.btnCerrarClick(Sender: TObject);
begin Self.Close;

end;

procedure TForm1.Button1Click(Sender: TObject);

begin
  // Note there are spaces in the string.

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // iNi
  // DoneVisualization := False;
  DecimalSeparator := ',';

  TS1 := TStringList.Create();
  TS2 := TStringList.Create();
  TS3 := TStringList.Create();

end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // DoneVisualization := True;
end;

procedure TForm1.btnCargarClick(Sender: TObject);
var
  ind: integer;
  StrLat, StrLon, StrLine: string;
  b:Boolean;
  j,k:integer;
  flag, cargar:Boolean;
begin

  // Abrir el dalogo
  b := OpenDialog1.Execute;
  cargar := False;

  // Nada seleccionado?
  if (not b) then begin
    Exit;
  end;

  // ini
  TS1{Memo1.Lines}.Clear;
  TS2{Memo2.Lines}.Clear;
  TS3{Memo3.Lines}.Clear;


  {Memo1.Lines}TS1.LoadFromFile(OpenDialog1.FileName);
  k := Pos('<coordinates>', TS1.Text);
  TS1.Text := Copy(TS1.Text, k, Length(TS1.Text));
  k := Pos('</coordinates>', TS1.Text);
  TS1.Text := Copy(TS1.Text, 1, k + Length('</coordinates>')-1);

  TS1.Text := AnsiReplaceText(TS1.Text, '<coordinates>', '<coordinates>'#13#10);
  TS1.Text := AnsiReplaceText(TS1.Text, ' ', #13#10);
//-debug-  TS1.SaveToFile('r:\coord.txt');

  // Cargar el fichero KML
  //  {Memo1.Lines}TS1.LoadFromFile(OpenDialog1.FileName);
  ind := 0;
  flag := False;
  // Extraer las lneas de coordenadas
  while (not flag) do begin
    StrLine := {Memo1.Lines}TS1[ind];
    // Empiezan las coordenadas
    if (AnsiPos('<coordinates>', Trim(StrLine)) <> 0) then begin
      // comenzar a leer coordenadas
      cargar := True;
    end
    else if (AnsiPos('</coordinates>', Trim(StrLine)) <> 0) then begin
      // acabamos
      cargar := False;
      flag := True;
    end
    else begin
      if (cargar) then begin
        {Memo2.Lines}TS2.Add(Trim(StrLine));
      end;
    end;

    // incrementar el indice
    Inc(ind);
  end; // while

  // Generar los datos para la pgina web
  for j := 0 to ({Memo2.Lines}TS2.count - 1) do begin

    // Extraer LATITUD
    StrLine := {Memo2.Lines}TS2[j];

    // Tiene algo?
    if (StrLine <> '') then begin
      k := Pos(',', StrLine);
      StrLat := Copy(StrLine, 1, k-1);

      // EXtraer LONGITUD
      StrLine := Copy(StrLine, k+1, Length(StrLine));
      k := Pos(',', StrLine);
      StrLon := Copy(StrLine, 1, k-1);

      if (j = 0) then begin
        // Aadir
        {Memo3.Lines}TS3.Add('new GLatLng(' + StrLon + ',' + StrLat + ')');
      end
      else begin
        {Memo3.Lines}TS3.Add(',new GLatLng(' + StrLon + ',' + StrLat + ')');
      end;
    end;
  end;

  // VISUALIZAR
  PageControl1.ActivePage := tsMap;
  pnlPos.Visible := True;
  _CenterPanel(pnlPos);
  pnlPos.BringToFront;
  PanelCentral.Visible := True;
  PanelCentral.Align := alClient;
  wbMapaGoogle.Visible := True;

  // StrLat := FloatToStr(latCenter);
  StrLat := STR_EMPTY;{AnsiReplaceText(StrLat, CHAR_COMMA, CHAR_POINT)};

  // StrLon := FloatToStr(lonCenter);
  StrLon := STR_EMPTY{AnsiReplaceText(StrLon, CHAR_COMMA, CHAR_POINT)};

  VisualizarMapa(wbMapaGoogle, StrLat, StrLon, pnlMapa.Height,
    pnlMapa.Width, 1, G_NORMAL_MAP, {Memo3.Lines}TS3.text);


end;

procedure TForm1.wbMapaGoogleDocumentComplete(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var
  Doc: IHTMLDocument2; // current HTML document
begin

  // panel
  pnlPos.Visible := False;
  Application.ProcessMessages;

  // ocultar barras de desplazamiento
  Doc := wbMapaGoogle.Document as IHTMLDocument2;
  Doc.Body.Style.overflow := 'hidden';
  // Completada la carga
  DoneVisualization := True;
  TSPoints := nil;
end;


procedure TForm1._CenterPanel(APanel: TPanel);
begin
  if (APanel.Parent is TWinControl) then begin
      APanel.Left := (TWinControl(APanel.Parent).Width - APanel.Width) Div 2;
    APanel.Top := (TWinControl(APanel.Parent).Height - APanel.Height) Div 2;
  end;
end;

end.
